#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc BinMenu {} {
    global ds9
    global menu

    set menu(bin,avg) [msgcat::mc "Average"]
    set menu(bin,sum) [msgcat::mc "Sum"]
    set menu(bin,block,in) [msgcat::mc "Block In"]
    set menu(bin,block,out) [msgcat::mc "Block Out"]
    set menu(bin,block,tofit) [msgcat::mc "Block to Fit Frame"]
    set menu(bin,block,1) [msgcat::mc "Block 1"]
    set menu(bin,block,2) [msgcat::mc "Block 2"]
    set menu(bin,block,4) [msgcat::mc "Block 4"]
    set menu(bin,block,8) [msgcat::mc "Block 8"]
    set menu(bin,block,16) [msgcat::mc "Block 16"]
    set menu(bin,block,32) [msgcat::mc "Block 32"]
    set menu(bin,block,64) [msgcat::mc "Block 64"]
    set menu(bin,block,128) [msgcat::mc "Block 128"]
    set menu(bin,buf,128) [msgcat::mc "128x128"]
    set menu(bin,buf,256) [msgcat::mc "256x256"]
    set menu(bin,buf,512) [msgcat::mc "512x512"]
    set menu(bin,buf,1024) [msgcat::mc "1024x1024"]
    set menu(bin,buf,2048) [msgcat::mc "2048x2048"]
    set menu(bin,buf,4096) [msgcat::mc "4096x4096"]
    set menu(bin,params) [msgcat::mc "Binning Parameters..."]

    menu $ds9(mb).bin -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Bin"
    $ds9(mb).bin add radiobutton -label $menu(bin,avg) \
	-variable bin(function) -value average -command ChangeBinFunction
    $ds9(mb).bin add radiobutton -label $menu(bin,sum) \
	-variable bin(function) -value sum -command ChangeBinFunction
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label $menu(bin,block,in) \
	-command {Bin .5 .5}
    $ds9(mb).bin add command -label $menu(bin,block,out) \
	-command {Bin 2 2}
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label $menu(bin,block,tofit) \
	-command BinToFit
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label $menu(bin,block,1) \
	-variable bin(factor) -value { 1 1 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label $menu(bin,block,2) \
	-variable bin(factor) -value { 2 2 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label $menu(bin,block,4) \
	-variable bin(factor) -value { 4 4 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label $menu(bin,block,8) \
	-variable bin(factor) -value { 8 8 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label $menu(bin,block,16) \
	-variable bin(factor) -value { 16 16 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label $menu(bin,block,32) \
	-variable bin(factor) -value { 32 32 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label $menu(bin,block,64) \
	-variable bin(factor) -value { 64 64 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label $menu(bin,block,128) \
	-variable bin(factor) -value { 128 128 } -command ChangeBinFactor
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label $menu(bin,buf,128) \
	-variable bin(buffersize) -value 128 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label $menu(bin,buf,256) \
	-variable bin(buffersize) -value 256 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label $menu(bin,buf,512) \
	-variable bin(buffersize) -value 512 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label $menu(bin,buf,1024) \
	-variable bin(buffersize) -value 1024 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label $menu(bin,buf,2048) \
	-variable bin(buffersize) -value 2048 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label $menu(bin,buf,4096) \
	-variable bin(buffersize) -value 4096 -command ChangeBinBufferSize
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label $menu(bin,params) -command BinDialog

    BinPrefsMenu
}

proc BinPrefsMenu {} {
    global ds9
    global menu
    global prefs

    menu $ds9(mb).prefs.bin -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,avg) \
	-variable prefs(bin,function) -value average
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,sum) \
	-variable prefs(bin,function) -value sum
    $ds9(mb).prefs.bin add separator
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,1) \
	-variable prefs(bin,factor) -value 1
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,2) \
	-variable prefs(bin,factor) -value 2
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,4) \
	-variable prefs(bin,factor) -value 4
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,8) \
	-variable prefs(bin,factor) -value 8
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,16) \
	-variable prefs(bin,factor) -value 16
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,32) \
	-variable prefs(bin,factor) -value 32
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,64) \
	-variable prefs(bin,factor) -value 64
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,block,128) \
	-variable prefs(bin,factor) -value 128
    $ds9(mb).prefs.bin add separator
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,buf,128) \
	-variable prefs(bin,buffersize) -value 128
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,buf,256) \
	-variable prefs(bin,buffersize) -value 256
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,buf,512) \
	-variable prefs(bin,buffersize) -value 512
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,buf,1024) \
	-variable prefs(bin,buffersize) -value 1024
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,buf,2048) \
	-variable prefs(bin,buffersize) -value 2048
    $ds9(mb).prefs.bin add radiobutton -label $menu(bin,buf,4096) \
	-variable prefs(bin,buffersize) -value 4096
}

proc BinButtons {} {
    global ds9
    global buttons

    set buttons(bin,block,in) [msgcat::mc "in"]
    set buttons(bin,block,out) [msgcat::mc "out"]
    set buttons(bin,block,tofit) [msgcat::mc "to fit"]
    set buttons(bin,block,1) [msgcat::mc "block 1"]
    set buttons(bin,block,2) [msgcat::mc "block 2"]
    set buttons(bin,block,4) [msgcat::mc "block 4"]
    set buttons(bin,block,8) [msgcat::mc "block 8"]
    set buttons(bin,block,16) [msgcat::mc "block 16"]
    set buttons(bin,block,32) [msgcat::mc "block 32"]
    set buttons(bin,block,64) [msgcat::mc "block 64"]
    set buttons(bin,block,128) [msgcat::mc "block 128"]

    frame $ds9(buttons).bin
    ButtonButton $ds9(buttons).bin.in $buttons(bin,block,in) {Bin .5 .5}
    ButtonButton $ds9(buttons).bin.out $buttons(bin,block,out) {Bin 2 2}
    ButtonButton $ds9(buttons).bin.tofit $buttons(bin,block,tofit) BinToFit
    RadioButton $ds9(buttons).bin.b1 $buttons(bin,block,1) \
	bin(factor) { 1 1 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b2 $buttons(bin,block,2) \
	bin(factor) { 2 2 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b4 $buttons(bin,block,4) \
	bin(factor) { 4 4 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b8 $buttons(bin,block,8) \
	bin(factor) { 8 8 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b16 $buttons(bin,block,16) \
	bin(factor) { 16 16 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b32 $buttons(bin,block,32) \
	bin(factor) { 32 32 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b64 $buttons(bin,block,64) \
	bin(factor) { 64 64 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b128 $buttons(bin,block,128) \
	bin(factor) { 128 128 } ChangeBinFactor
}

proc UpdateBinMenu {} {
    global ds9
    global current
    global bin
    global menu

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateBinMenu"
    }

    if {$current(frame) != {}} {
	if {[$current(frame) has fits]} {
	    if {[$current(frame) has bin]} {
		$ds9(mb) entryconfig $menu(bin) -state normal
		$ds9(buttons).major.bin configure -state normal
	    } else {
		$ds9(mb) entryconfig $menu(bin) -state disabled
		$ds9(buttons).major.bin configure -state disabled
	    }
	} else {
	    $ds9(mb) entryconfig $menu(bin) -state normal
	    $ds9(buttons).major.bin configure -state normal
	}

	set bin(function) [$current(frame) get bin function]
	set bin(factor) "[$current(frame) get bin factor]"
	set bin(depth) [$current(frame) get bin depth]
	set bin(buffersize) [$current(frame) get bin buffer size]
    } else {
	$ds9(mb) entryconfig $menu(bin) -state disabled
	$ds9(buttons).major.bin configure -state disabled
    }
}

