#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc InitLanguage {} {
    global menu

    # main menu items
    set menu(file) [msgcat::mc "File"]
    set menu(edit) [msgcat::mc "Edit"]
    set menu(view) [msgcat::mc "View"]
    set menu(frame) [msgcat::mc "Frame"]
    set menu(bin) [msgcat::mc "Bin"]
    set menu(zoom) [msgcat::mc "Zoom"]
    set menu(scale) [msgcat::mc "Scale"]
    set menu(color) [msgcat::mc "Color"]
    set menu(region) [msgcat::mc "Region"]
    set menu(wcs) [msgcat::mc "WCS"]
    set menu(analysis) [msgcat::mc "Analysis"]
    set menu(help) [msgcat::mc "Help"]

    # common file menu items
    set menu(file,open) [msgcat::mc "Open..."]
    set menu(file,close) [msgcat::mc "Close"]
    set menu(file,load) [msgcat::mc "Load..."]
    set menu(file,save) [msgcat::mc "Save..."]
    set menu(file,apply) [msgcat::mc "Apply"]
    set menu(file,cancel) [msgcat::mc "Cancel"]
    set menu(file,print) [msgcat::mc "Print..."]
    set menu(file,page) [msgcat::mc "Page Setup..."]
    set menu(file,ok) [msgcat::mc "OK"]
    set menu(file,clear) [msgcat::mc "Clear"]
    set menu(file,retrieve) [msgcat::mc "Retrieve"]
    set menu(file,generate) [msgcat::mc "Generate"]

    # common edit menu items
    set menu(edit,undo) [msgcat::mc "Undo"]
    set menu(edit,cut) [msgcat::mc "Cut"]
    set menu(edit,copy) [msgcat::mc "Copy"]
    set menu(edit,paste) [msgcat::mc "Paste"]
    set menu(edit,clear) [msgcat::mc "Clear"]

    # common wcs menu items
    set menu(wcs,image) [msgcat::mc "Image"]
    set menu(wcs,physical) [msgcat::mc "Physical"]
    set menu(wcs,amplifier) [msgcat::mc "Amplifier"]
    set menu(wcs,detector) [msgcat::mc "Detector"]
    set menu(wcs,multi) [msgcat::mc "Multiple WCS"]
    set menu(wcs,fk4) [msgcat::mc "Equatorial B1950"]
    set menu(wcs,fk5) [msgcat::mc "Equatorial J2000"]
    set menu(wcs,icrs) [msgcat::mc "ICRS"]
    set menu(wcs,galactic) [msgcat::mc "Galactic"]
    set menu(wcs,ecliptic) [msgcat::mc "Ecliptic"]
    set menu(wcs,degrees) [msgcat::mc "Degrees"]
    set menu(wcs,arcmin) [msgcat::mc "ArcMin"]
    set menu(wcs,arcsec) [msgcat::mc "ArcSec"]
    set menu(wcs,sexagesimal) [msgcat::mc "Sexagesimal"]
    set menu(wcs,hms) [msgcat::mc "HMS/DMS"]

    # common shape menu items
    set menu(shape,circle) [msgcat::mc "Circle"]
    set menu(shape,ellipse) [msgcat::mc "Ellipse"]
    set menu(shape,box) [msgcat::mc "Box"]
    set menu(shape,polygon) [msgcat::mc "Polygon"]
    set menu(shape,line) [msgcat::mc "Line"]
    set menu(shape,vector) [msgcat::mc "Vector"]
    set menu(shape,text) [msgcat::mc "Text"]
    set menu(shape,ruler) [msgcat::mc "Ruler"]
    set menu(shape,compass) [msgcat::mc "Compass"]
    set menu(shape,projection) [msgcat::mc "Projection"]
    set menu(shape,annulus) [msgcat::mc "Annulus"]
    set menu(shape,annulus,ellipse) [msgcat::mc "Elliptical Annulus"]
    set menu(shape,annulus,box) [msgcat::mc "Box Annulus"]
    set menu(shape,panda) [msgcat::mc "Panda"]
    set menu(shape,panda,ellipse) [msgcat::mc "Elliptical Panda"]
    set menu(shape,panda,box) [msgcat::mc "Box Panda"]
    set menu(shape,point,circle) [msgcat::mc "Circle Point"]
    set menu(shape,point,box) [msgcat::mc "Box Point"]
    set menu(shape,point,diamond) [msgcat::mc "Diamond Point"]
    set menu(shape,point,cross) [msgcat::mc "Cross Point"]
    set menu(shape,point,x) [msgcat::mc "X Point"]
    set menu(shape,point,arrow) [msgcat::mc "Arrow Point"]
    set menu(shape,point,boxcircle) [msgcat::mc "BoxCircle Point"]

    # common color menu items
    set menu(color,black) [msgcat::mc "Black"]
    set menu(color,white) [msgcat::mc "White"]
    set menu(color,red) [msgcat::mc "Red"]
    set menu(color,green) [msgcat::mc "Green"]
    set menu(color,blue) [msgcat::mc "Blue"]
    set menu(color,cyan) [msgcat::mc "Cyan"]
    set menu(color,magenta) [msgcat::mc "Magenta"]
    set menu(color,yellow) [msgcat::mc "Yellow"]

    # common fonts menu items
    set menu(font,times) [msgcat::mc "Times"]
    set menu(font,helvetica) [msgcat::mc "Helvetica"]
    set menu(font,symbol) [msgcat::mc "Symbol"]
    set menu(font,courier) [msgcat::mc "Courier"]
    set menu(font,plain) [msgcat::mc "Plain"]
    set menu(font,bold) [msgcat::mc "Bold"]
    set menu(font,italic) [msgcat::mc "Italic"]
}

proc CreateMenuBar {} {
    global ds9
    global menu

    menu $ds9(mb) -selectcolor $menu(selectcolor)
    $ds9(mb) add cascade -label $menu(file) -menu $ds9(mb).file
    $ds9(mb) add cascade -label $menu(edit) -menu $ds9(mb).edit
    $ds9(mb) add cascade -label $menu(view) -menu $ds9(mb).view
    $ds9(mb) add cascade -label $menu(frame) -menu $ds9(mb).frame
    $ds9(mb) add cascade -label $menu(bin) -menu $ds9(mb).bin
    $ds9(mb) add cascade -label $menu(zoom) -menu $ds9(mb).zoom
    $ds9(mb) add cascade -label $menu(scale) -menu $ds9(mb).scale
    $ds9(mb) add cascade -label $menu(color) -menu $ds9(mb).color
    $ds9(mb) add cascade -label $menu(region) -menu $ds9(mb).region
    $ds9(mb) add cascade -label $menu(wcs) -menu $ds9(mb).wcs
    $ds9(mb) add cascade -label $menu(analysis) -menu $ds9(mb).analysis
    $ds9(mb) add cascade -label $menu(help) -menu $ds9(mb).help

    PrefsMenu

    FileMenu
    EditMenu
    ViewMenu
    FrameMenu
    BinMenu
    ZoomMenu
    ScaleMenu
    ColorMenu
    RegionMenu
    WCSMenu
    AnalysisMenu
    HelpMenu
}

# full coordinate menu
proc UpdateCoordMenu {frame which} {
    global current
    global ds9
    global menu

    # no frame
    if {$frame == {}} {
	SetCoordMenu $which normal
	return
    }

    # unloaded frame
    if {![$frame has fits]} {
	SetCoordMenu $which normal
	return
    }

    # loaded frame
    if {[$frame has wcs WCS]} {
	$which entryconfig $menu(wcs) -state normal
    } else {
	$which entryconfig $menu(wcs) -state disabled
    }
    $which entryconfig $menu(wcs,multi) -state normal
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {[$frame has wcs WCS$l]} {
	    $which.wcs entryconfig "$menu(wcs) $l" -state normal
	} else {
	    $which.wcs entryconfig "$menu(wcs) $l" -state disabled
	}
    }

    if {[$frame has wcs equatorial WCS]} {
	SetSkyFrameMenu $which normal
    } else {
	SetSkyFrameMenu $which disabled
    }

    if {[$frame has detector]} {
	$which entryconfig $menu(wcs,detector) -state normal
    } else {
	$which entryconfig $menu(wcs,detector) -state disabled
    }
    
    if {[$frame has amplifier]} {
	$which entryconfig $menu(wcs,amplifier) -state normal
    } else {
	$which entryconfig $menu(wcs,amplifier) -state disabled
    }

    if {[$frame has physical]} {
	$which entryconfig $menu(wcs,physical) -state normal
    } else {
	$which entryconfig $menu(wcs,physical) -state disabled
    }

    $which entryconfig $menu(wcs,image) -state normal
}

proc SetCoordMenu {which value} {
    global ds9
    global menu

    $which entryconfig $menu(wcs) -state $value
    $which entryconfig $menu(wcs,multi) -state $value
    $which entryconfig $menu(wcs,image) -state $value
    $which entryconfig $menu(wcs,physical) -state $value
    $which entryconfig $menu(wcs,amplifier) -state $value
    $which entryconfig $menu(wcs,detector) -state $value

    $which entryconfig $menu(wcs,fk4) -state $value
    $which entryconfig $menu(wcs,fk5) -state $value
    $which entryconfig $menu(wcs,icrs) -state $value
    $which entryconfig $menu(wcs,galactic) -state $value
    $which entryconfig $menu(wcs,ecliptic) -state $value

    $which entryconfig $menu(wcs,degrees) -state $value
    $which entryconfig $menu(wcs,sexagesimal) -state $value

    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$which.wcs entryconfig "$menu(wcs) $l" -state $value
    }
}

proc SetSkyFrameMenu {which value} {
    global menu

    $which entryconfig $menu(wcs,fk4) -state $value
    $which entryconfig $menu(wcs,fk5) -state $value
    $which entryconfig $menu(wcs,icrs) -state $value
    $which entryconfig $menu(wcs,galactic) -state $value
    $which entryconfig $menu(wcs,ecliptic) -state $value

    $which entryconfig $menu(wcs,degrees) -state $value
    $which entryconfig $menu(wcs,sexagesimal) -state $value
}

proc SetSkyFrameMenu2 {which value} {
    global menu

    $which entryconfig $menu(wcs,fk4) -state $value
    $which entryconfig $menu(wcs,fk5) -state $value
    $which entryconfig $menu(wcs,icrs) -state $value
    $which entryconfig $menu(wcs,galactic) -state $value
    $which entryconfig $menu(wcs,ecliptic) -state $value
}

# dist menu
proc UpdateDistMenu {frame which defnoframe defnofits} {
    global current
    global ds9
    global menu

    # no frame
    if {$frame == {}} {
	if {$defnoframe} {
	    SetDistMenu $which normal
	} else {
	    SetDistMenu $which disabled
	}
	return
    }

    # unloaded frame
    if {![$frame has fits]} {
	if {$defnofits} {
	    SetDistMenu $which normal
	} else {
	    SetDistMenu $which disabled
	}
	return
    }

    # loaded frame
    if {[$frame has wcs WCS]} {
	$which entryconfig $menu(wcs) -state normal
    } else {
	$which entryconfig $menu(wcs) -state disabled
    }
    $which entryconfig $menu(wcs,multi) -state normal
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {[$frame has wcs WCS$l]} {
	    $which.wcs entryconfig "$menu(wcs) $l" -state normal
	} else {
	    $which.wcs entryconfig "$menu(wcs) $l" -state disabled
	}
    }

    if {[$frame has wcs equatorial WCS]} {
	SetSkyFormatMenu $which normal
    } else {
	SetSkyFormatMenu $which disabled
    }

    if {[$frame has detector]} {
	$which entryconfig $menu(wcs,detector) -state normal
    } else {
	$which entryconfig $menu(wcs,detector) -state disabled
    }

    if {[$frame has amplifier]} {
	$which entryconfig $menu(wcs,amplifier) -state normal
    } else {
	$which entryconfig $menu(wcs,amplifier) -state disabled
    }

    if {[$frame has physical]} {
	$which entryconfig $menu(wcs,physical) -state normal
    } else {
	$which entryconfig $menu(wcs,physical) -state disabled
    }

    $which entryconfig $menu(wcs,image) -state normal
}

proc SetDistMenu {which value} {
    global ds9
    global menu

    $which entryconfig $menu(wcs) -state $value
    $which entryconfig $menu(wcs,multi) -state $value
    $which entryconfig $menu(wcs,image) -state $value
    $which entryconfig $menu(wcs,physical) -state $value
    $which entryconfig $menu(wcs,amplifier) -state $value
    $which entryconfig $menu(wcs,detector) -state $value

    $which entryconfig $menu(wcs,degrees) -state $value
    $which entryconfig $menu(wcs,arcmin) -state $value
    $which entryconfig $menu(wcs,arcsec) -state $value

    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$which.wcs entryconfig "$menu(wcs) $l" -state $value
    }
}

proc SetSkyFormatMenu {which value} {
    global menu

    $which entryconfig $menu(wcs,degrees) -state $value
    $which entryconfig $menu(wcs,arcmin) -state $value
    $which entryconfig $menu(wcs,arcsec) -state $value
}

proc AdjustCoord {frame sysname} {
    upvar $sysname sys

    if {$frame != ""} {
	if {[$frame has fits]} {
	    switch -- $sys {
		image {}
		physical {
		    if {![$frame has physical]} {
			set sys image
		    }
		}
		amplifier {
		    if {![$frame has amplifier]} {
			set sys image
		    }
		}
		detector {
		    if {![$frame has detector]} {
			set sys image
		    }
		}
		wcs {
		    if {![$frame has wcs $sys]} {
			set sys image
		    }
		}
		default {
		    if {![$frame has wcs $sys]} {
			if [$frame has wcs wcs] {
			    set sys wcs
			} else {
			    set sys image
			}
		    }
		}
	    }
	}
    }
}

proc AdjustDist {frame sysname} {
    upvar $sysname sys
    global current

    if {$frame != {}} {
	if {[$frame has fits]} {
	    switch -- $sys {
		image {}
		physical {
		    if {![$frame has physical]} {
			set sys image
		    }
		}
		amplifier {
		    if {![$frame has amplifier]} {
			set sys image
		    }
		}
		detector {
		    if {![$frame has detector]} {
			set sys image
		    }
		}
		default {
		    if {![$frame has wcs $sys]} {
			set sys wcs
		    }
		}
	    }
	}
    }
}

proc OptionMenu {w varName args} {
    upvar #0 $varName var
    global $varName

    menubutton $w -indicatoron 1 -menu $w.menu -relief raised -bd 2 \
	-highlightthickness 2 -anchor c -direction flush
    menu $w.menu -tearoff 0
    foreach ff $args {
	set aa [lindex $ff 0]
	set bb [lindex $ff 1]
	if {$bb == $var} {
	    $w config -text $aa
	}

    	$w.menu add radiobutton -label $aa \
	    -variable $varName -value $bb \
	    -command [list $w config -text $aa]
    }

    return $w.menu
}
