#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc HelpMenu {} {
    global ds9
    global menu

    set menu(help,ref) [msgcat::mc "Reference Manual"]
    set menu(help,keyboard) [msgcat::mc "Keyboard Shortcuts"]
    set menu(help,faq) [msgcat::mc "FAQ"]
    set menu(help,new) [msgcat::mc "New Features"]
    set menu(help,issues) [msgcat::mc "Known Issues"]
    set menu(help,release) [msgcat::mc "Release Notes"]
    set menu(help,desk) [msgcat::mc "Help Desk"]
    set menu(help,ack) [msgcat::mc "Acknowledgment"]
    set menu(help,home) [msgcat::mc "DS9 Home Page"]

    menu $ds9(mb).help -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Help"
    $ds9(mb).help add command -label $menu(help,ref) -command HelpRef
    $ds9(mb).help add command -label $menu(help,keyboard) -command HelpKeyboard
    $ds9(mb).help add separator
    $ds9(mb).help add command -label $menu(help,faq) -command HelpFAQ
    $ds9(mb).help add command -label $menu(help,new) -command HelpNew
    $ds9(mb).help add command -label $menu(help,issues) -command HelpIssue
    $ds9(mb).help add command -label $menu(help,release) -command HelpRelease
    $ds9(mb).help add command -label $menu(help,desk) -command HelpDesk
    $ds9(mb).help add separator
    $ds9(mb).help add command -label $menu(help,ack) -command HelpAck
    $ds9(mb).help add command -label $menu(help,home) -command HelpHome
}

proc HelpButtons {} {
    global ds9
    global buttons
    global help

    set buttons(help,ref) [msgcat::mc "reference"]
    set buttons(help,keyboard) [msgcat::mc "keyboard"]
    set buttons(help,faq) [msgcat::mc "faq"]
    set buttons(help,new) [msgcat::mc "new"]
    set buttons(help,issues) [msgcat::mc "known issues"]
    set buttons(help,release) [msgcat::mc "release"]
    set buttons(help,desk) [msgcat::mc "help desk"]
    set buttons(help,ack) [msgcat::mc "acknowledgment"]
    set buttons(help,home) [msgcat::mc "home"]

    frame $ds9(buttons).help
    ButtonButton $ds9(buttons).help.ref $buttons(help,ref) HelpRef
    ButtonButton $ds9(buttons).help.keyboard $buttons(help,keyboard) \
	HelpKeyboard
    ButtonButton $ds9(buttons).help.faq $buttons(help,faq) HelpFAQ
    ButtonButton $ds9(buttons).help.new $buttons(help,new) HelpNew
    ButtonButton $ds9(buttons).help.known $buttons(help,issues) HelpIssue
    ButtonButton $ds9(buttons).help.release $buttons(help,release) HelpRelease
    ButtonButton $ds9(buttons).help.desk $buttons(help,desk) HelpDesk
    ButtonButton $ds9(buttons).help.ack $buttons(help,ack) HelpAck
    ButtonButton $ds9(buttons).help.home $buttons(help,home) HelpHome
}

