#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc WCSMenu {} {
    global ds9
    global menu

    menu $ds9(mb).wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).wcs add radiobutton -label $menu(wcs) \
	-variable wcs(system) -value wcs -command UpdateWCS
    $ds9(mb).wcs add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).wcs.wcs
    $ds9(mb).wcs add separator
    $ds9(mb).wcs add radiobutton -label $menu(wcs,fk4) \
	-variable wcs(sky) -value fk4 -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label $menu(wcs,fk5) \
	-variable wcs(sky) -value fk5 -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label $menu(wcs,icrs) \
	-variable wcs(sky) -value icrs -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label $menu(wcs,galactic) \
	-variable wcs(sky) -value galactic -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label $menu(wcs,ecliptic) \
	-variable wcs(sky) -value ecliptic -command UpdateWCS
    $ds9(mb).wcs add separator
    $ds9(mb).wcs add radiobutton -label $menu(wcs,degrees) \
	-variable wcs(skyformat) -value degrees -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label $menu(wcs,sexagesimal) \
	-variable wcs(skyformat) -value sexagesimal -command UpdateWCS

    menu $ds9(mb).wcs.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).wcs.wcs add radiobutton -label "$menu(wcs) $l" \
	    -variable wcs(system) -value "wcs$l" -command UpdateWCS
    }

    WCSPrefsMenu
}

proc WCSPrefsMenu {} {
    global ds9
    global menu 
    global prefs

    menu $ds9(mb).prefs.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs) \
	-variable prefs(wcs,system) -value wcs
    $ds9(mb).prefs.wcs add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.wcs.wcs
    $ds9(mb).prefs.wcs add separator
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs,fk4) \
	-variable prefs(wcs,sky) -value fk4
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs,fk5) \
	-variable prefs(wcs,sky) -value fk5
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs,icrs) \
	-variable prefs(wcs,sky) -value icrs
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs,galactic) \
	-variable prefs(wcs,sky) -value galactic
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs,ecliptic) \
	-variable prefs(wcs,sky) -value ecliptic
    $ds9(mb).prefs.wcs add separator
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs,degrees) \
	-variable prefs(wcs,skyformat) -value degrees
    $ds9(mb).prefs.wcs add radiobutton -label $menu(wcs,sexagesimal) \
	-variable prefs(wcs,skyformat) -value sexagesimal

    menu $ds9(mb).prefs.wcs.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.wcs.wcs add radiobutton -label "$menu(wcs) $l" \
	    -variable prefs(wcs,system) -value "wcs$l"
    }
}

proc WCSButtons {} {
    global ds9
    global buttons
    global wcs

    frame $ds9(buttons).wcs1
    RadioButton $ds9(buttons).wcs1.fk4 $buttons(wcs,fk4) \
	wcs(sky) fk4 UpdateWCS
    RadioButton $ds9(buttons).wcs1.fk5 $buttons(wcs,fk5) \
	wcs(sky) fk5 UpdateWCS
    RadioButton $ds9(buttons).wcs1.icrs $buttons(wcs,icrs) \
	wcs(sky) icrs UpdateWCS
    RadioButton $ds9(buttons).wcs1.galactic $buttons(wcs,galactic) \
	wcs(sky) galactic UpdateWCS
    RadioButton $ds9(buttons).wcs1.ecliptic $buttons(wcs,ecliptic) \
	wcs(sky) ecliptic UpdateWCS
    RadioButton $ds9(buttons).wcs1.degrees $buttons(wcs,degrees) \
	wcs(skyformat) degrees UpdateWCS
    RadioButton $ds9(buttons).wcs1.sexagesimal $buttons(wcs,sexagesimal) \
	wcs(skyformat) sexagesimal UpdateWCS
    RadioButton $ds9(buttons).wcs1.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).wcs2 MajorButton

    frame $ds9(buttons).wcs2
    RadioButton $ds9(buttons).wcs2.wcs wcs wcs(system) wcs UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsa wcsa wcs(system) wcsa UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsb wcsb wcs(system) wcsb UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsc wcsc wcs(system) wcsc UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsd wcsd wcs(system) wcsd UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcse wcse wcs(system) wcse UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsf wcsf wcs(system) wcsf UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsg wcsg wcs(system) wcsg UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsh wcsh wcs(system) wcsh UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsi wcsi wcs(system) wcsi UpdateWCS
    RadioButton $ds9(buttons).wcs2.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).wcs3 MajorButton

    frame $ds9(buttons).wcs3
    RadioButton $ds9(buttons).wcs3.wcsj wcsj wcs(system) wcsj UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsk wcsk wcs(system) wcsk UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsl wcsl wcs(system) wcsl UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsm wcsm wcs(system) wcsm UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsn wcsn wcs(system) wcsn UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcso wcso wcs(system) wcso UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsp wcsp wcs(system) wcsp UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsq wcsq wcs(system) wcsq UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsr wcsr wcs(system) wcsr UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcss wcss wcs(system) wcss UpdateWCS
    RadioButton $ds9(buttons).wcs3.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).wcs4 MajorButton

    frame $ds9(buttons).wcs4
    RadioButton $ds9(buttons).wcs4.wcst wcst wcs(system) wcst UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsu wcsu wcs(system) wcsu UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsv wcsv wcs(system) wcsv UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsw wcsw wcs(system) wcsw UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsx wcsx wcs(system) wcsx UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsy wcsy wcs(system) wcsy UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsz wcsz wcs(system) wcsz UpdateWCS
    RadioButton $ds9(buttons).wcs4.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).wcs1 MajorButton
}

proc UpdateWCSMenu {} {
    global ds9
    global current
    global menu
    global wcs

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateWCSMenu"
    }

    # check for valid values 
    # bad, can't let wcs(system) change to non wcs value
    # AdjustCoord $current(frame) wcs(system)

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig $menu(wcs) -state normal
	$ds9(buttons).major.wcs1 configure -state normal

	UpdateWCSCoordMenu "$current(frame)" $ds9(mb).wcs

    } else {
	$ds9(mb) entryconfig $menu(wcs) -state disabled
	$ds9(buttons).major.wcs1 configure -state disabled
    }
}

# full WCS coordinate menu
proc UpdateWCSCoordMenu {frame which} {
    global current
    global ds9
    global menu

    # no frame
    if {$frame == {}} {
	SetWCSCoordMenu $which disabled
	return
    }

    # unloaded frame
    if {![$frame has fits]} {
	SetWCSCoordMenu $which normal
	return
    }

    # loaded frame
    if {[$frame has wcs WCS]} {
	$which entryconfig $menu(wcs) -state normal
    } else {
	$which entryconfig $menu(wcs) -state disabled
    }
    $which entryconfig $menu(wcs,multi) -state normal
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {[$frame has wcs WCS$l]} {
	    $which.wcs entryconfig "$menu(wcs) $l" -state normal
	} else {
	    $which.wcs entryconfig "$menu(wcs) $l" -state disabled
	}
    }

    if {[$frame has wcs equatorial WCS]} {
	SetSkyFrameMenu $which normal
    } else {
	SetSkyFrameMenu $which disable
    }
}

proc SetWCSCoordMenu {which value} {
    global ds9
    global menu

    $which entryconfig $menu(wcs) -state $value
    $which entryconfig $menu(wcs,multi) -state $value

    $which entryconfig $menu(wcs,fk4) -state $value
    $which entryconfig $menu(wcs,fk5) -state $value
    $which entryconfig $menu(wcs,icrs) -state $value
    $which entryconfig $menu(wcs,galactic) -state $value
    $which entryconfig $menu(wcs,ecliptic) -state $value

    $which entryconfig $menu(wcs,degrees) -state $value
    $which entryconfig $menu(wcs,sexagesimal) -state $value

    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$which.wcs entryconfig "$menu(wcs) $l" -state $value
    }
}

