#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc ZoomMenu {} {
    global ds9
    global menu

    set menu(zoom,center) [msgcat::mc "Center Image"]
    set menu(zoom,align) [msgcat::mc "Align"]
    set menu(zoom,align,wcs) [msgcat::mc "Align WCS"]
    set menu(zoom,zoom,in) [msgcat::mc "Zoom In"]
    set menu(zoom,zoom,out) [msgcat::mc "Zoom Out"]
    set menu(zoom,zoom,tofit) [msgcat::mc "Zoom to Fit Frame"]
    set menu(zoom,zoom,1/32) [msgcat::mc "Zoom 1/32"]
    set menu(zoom,zoom,1/16) [msgcat::mc "Zoom 1/16"]
    set menu(zoom,zoom,1/8) [msgcat::mc "Zoom 1/8"]
    set menu(zoom,zoom,1/4) [msgcat::mc "Zoom 1/4"]
    set menu(zoom,zoom,1/2) [msgcat::mc "Zoom 1/2"]
    set menu(zoom,zoom,1) [msgcat::mc "Zoom 1"]
    set menu(zoom,zoom,2) [msgcat::mc "Zoom 2"]
    set menu(zoom,zoom,4) [msgcat::mc "Zoom 4"]
    set menu(zoom,zoom,8) [msgcat::mc "Zoom 8"]
    set menu(zoom,zoom,16) [msgcat::mc "Zoom 16"]
    set menu(zoom,zoom,32) [msgcat::mc "Zoom 32"]
    set menu(zoom,invert,none) [msgcat::mc "None"]
    set menu(zoom,invert,x) [msgcat::mc "Invert X"]
    set menu(zoom,invert,y) [msgcat::mc "Invert Y"]
    set menu(zoom,invert,xy) [msgcat::mc "Invert XY"]
    set menu(zoom,rot,0) [msgcat::mc "0 deg"]
    set menu(zoom,rot,90) [msgcat::mc "90 deg"]
    set menu(zoom,rot,180) [msgcat::mc "180 deg"]
    set menu(zoom,rot,270) [msgcat::mc "270 deg"]
    set menu(zoom,params) [msgcat::mc "Pan Zoom Rotate To..."]

    menu $ds9(mb).zoom -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Zoom"
    $ds9(mb).zoom add command -label $menu(zoom,center) \
	-command CenterCurrentFrame
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add checkbutton -label $menu(zoom,align) \
	-variable wcs(align) -command AlignWCSFrame
    $ds9(mb).zoom add cascade -label $menu(zoom,align,wcs) \
	-menu $ds9(mb).zoom.align
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label $menu(zoom,zoom,in) -command {Zoom 2 2}
    $ds9(mb).zoom add command -label $menu(zoom,zoom,out) -command {Zoom .5 .5}
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label $menu(zoom,zoom,tofit) -command ZoomToFit
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,1/32) \
	-variable current(zoom) -value { 0.03125 0.03125 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,1/16) \
	-variable current(zoom) -value { 0.0625 0.0625 }  -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,1/8) \
	-variable current(zoom) -value { 0.125 0.125 }  -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,1/4) \
	-variable current(zoom) -value { 0.25 0.25 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,1/2) \
	-variable current(zoom) -value { 0.5 0.5 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,1) \
	-variable current(zoom) -value { 1 1 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,2) \
	-variable current(zoom) -value { 2 2 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,4) \
	-variable current(zoom) -value { 4 4 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,8) \
	-variable current(zoom) -value { 8 8 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,16) \
	-variable current(zoom) -value { 16 16 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label $menu(zoom,zoom,32) \
	-variable current(zoom) -value { 32 32 } -command ChangeZoom
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label $menu(zoom,invert,none) \
	-variable current(orient) -value none -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label $menu(zoom,invert,x) \
	-variable current(orient) -value x -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label $menu(zoom,invert,y) \
	-variable current(orient) -value y -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label $menu(zoom,invert,xy) \
	-variable current(orient) -value xy -command ChangeOrient
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label $menu(zoom,rot,0) \
	-variable current(rotate) -value 0 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label $menu(zoom,rot,90) \
	-variable current(rotate) -value 90 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label $menu(zoom,rot,180) \
	-variable current(rotate) -value 180 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label $menu(zoom,rot,270) \
	-variable current(rotate) -value 270 -command ChangeRotate
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label $menu(zoom,params) \
	-command PanZoomDialog

    menu $ds9(mb).zoom.align -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Zoom Align"
    $ds9(mb).zoom.align add radiobutton -label $menu(wcs) \
	-variable wcs(align,system) -value wcs -command AlignWCSFrame
    $ds9(mb).zoom.align add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).zoom.align.wcs
    $ds9(mb).zoom.align add separator
    $ds9(mb).zoom.align add radiobutton -label $menu(wcs,fk4) \
	-variable wcs(align,sky) -value fk4 -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton -label $menu(wcs,fk5) \
	-variable wcs(align,sky) -value fk5 -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton -label $menu(wcs,icrs) \
	-variable wcs(align,sky) -value icrs -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton -label $menu(wcs,galactic) \
	-variable wcs(align,sky) -value galactic -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton -label $menu(wcs,ecliptic) \
	-variable wcs(align,sky) -value ecliptic -command AlignWCSFrame

    menu $ds9(mb).zoom.align.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).zoom.align.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable wcs(align,system) -value "wcs$l" -command AlignWCSFrame
    }

    ZoomPrefsMenu
}

proc ZoomPrefsMenu {} {
    global ds9
    global menu 
    global prefs

    menu $ds9(mb).prefs.zoom -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.zoom add checkbutton -label $menu(zoom,align) \
	-variable prefs(wcs,align)
    $ds9(mb).prefs.zoom add cascade -label $menu(zoom,align,wcs) \
	-menu $ds9(mb).prefs.zoom.align
    $ds9(mb).prefs.zoom add separator
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,1/32) \
	-variable prefs(zoom) -value { 0.03125 0.03125 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,1/16) \
	-variable prefs(zoom) -value { 0.0625 0.0625 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,1/8) \
	-variable prefs(zoom) -value { 0.125 0.125 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,1/4) \
	-variable prefs(zoom) -value { 0.25 0.25 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,1/2) \
	-variable prefs(zoom) -value { 0.5 0.5 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,1) \
	-variable prefs(zoom) -value { 1 1 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,2) \
	-variable prefs(zoom) -value { 2 2 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,4) \
	-variable prefs(zoom) -value { 4 4 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,8) \
	-variable prefs(zoom) -value { 8 8 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,16) \
	-variable prefs(zoom) -value { 16 16 }
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,zoom,32) \
	-variable prefs(zoom) -value { 32 32 }
    $ds9(mb).prefs.zoom add separator
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,invert,none) \
	-variable prefs(orient) -value none
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,invert,x) \
	-variable prefs(orient) -value x
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,invert,y) \
	-variable prefs(orient) -value y
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,invert,xy) \
	-variable prefs(orient) -value xy
    $ds9(mb).prefs.zoom add separator
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,rot,0) \
	-variable prefs(rotate) -value 0 
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,rot,90) \
	-variable prefs(rotate) -value 90
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,rot,180) \
	-variable prefs(rotate) -value 180
    $ds9(mb).prefs.zoom add radiobutton -label $menu(zoom,rot,270) \
	-variable prefs(rotate) -value 270

    menu $ds9(mb).prefs.zoom.align -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.zoom.align add radiobutton -label $menu(wcs) \
	-variable prefs(wcs,align,system) -value wcs
    $ds9(mb).prefs.zoom.align add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.zoom.align.wcs
    $ds9(mb).prefs.zoom.align add separator
    $ds9(mb).prefs.zoom.align add radiobutton \
	-label $menu(wcs,fk4) \
	-variable prefs(wcs,align,sky) -value fk4
    $ds9(mb).prefs.zoom.align add radiobutton \
	-label $menu(wcs,fk5) \
	-variable prefs(wcs,align,sky) -value fk5
    $ds9(mb).prefs.zoom.align add radiobutton \
	-label $menu(wcs,icrs) \
	-variable prefs(wcs,align,sky) -value icrs
    $ds9(mb).prefs.zoom.align add radiobutton \
	-label $menu(wcs,galactic) \
	-variable prefs(wcs,align,sky) -value galactic
    $ds9(mb).prefs.zoom.align add radiobutton \
	-label $menu(wcs,ecliptic) \
	-variable prefs(wcs,align,sky) -value ecliptic

    menu $ds9(mb).prefs.zoom.align.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.zoom.align.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable prefs(wcs,align,system) -value "wcs$l"
    }
}

proc ZoomButtons {} {
    global ds9
    global buttons
    global wcs

    set buttons(zoom,center) [msgcat::mc "center"]
    set buttons(zoom,align) [msgcat::mc "align"]
    set buttons(zoom,zoom,in) [msgcat::mc "in"]
    set buttons(zoom,zoom,out) [msgcat::mc "out"]
    set buttons(zoom,zoom,tofit) [msgcat::mc "to fit"]
    set buttons(zoom,invert,none) [msgcat::mc "none"]
    set buttons(zoom,invert,x) [msgcat::mc "x"]
    set buttons(zoom,invert,y) [msgcat::mc "y"]
    set buttons(zoom,invert,xy) [msgcat::mc "xy"]
    set buttons(zoom,rot,0) [msgcat::mc "0 deg"]
    set buttons(zoom,rot,90) [msgcat::mc "90 deg"]
    set buttons(zoom,rot,180) [msgcat::mc "180 deg"]
    set buttons(zoom,rot,270) [msgcat::mc "270 deg"]

    frame $ds9(buttons).zoom
    ButtonButton $ds9(buttons).zoom.center $buttons(zoom,center) \
	CenterCurrentFrame
    CheckButton $ds9(buttons).zoom.align $buttons(zoom,align) wcs(align) \
	AlignWCSFrame
    ButtonButton $ds9(buttons).zoom.in $buttons(zoom,zoom,in) {Zoom 2 2}
    ButtonButton $ds9(buttons).zoom.out $buttons(zoom,zoom,out) {Zoom .5 .5}
    ButtonButton $ds9(buttons).zoom.fit $buttons(zoom,zoom,tofit) ZoomToFit
    RadioButton $ds9(buttons).zoom.none $buttons(zoom,invert,none) \
	current(orient) none ChangeOrient
    RadioButton $ds9(buttons).zoom.x $buttons(zoom,invert,x) \
	current(orient) x ChangeOrient
    RadioButton $ds9(buttons).zoom.y $buttons(zoom,invert,y)  \
	current(orient) y ChangeOrient
    RadioButton $ds9(buttons).zoom.xy $buttons(zoom,invert,xy) \
	current(orient) xy ChangeOrient
    RadioButton $ds9(buttons).zoom.r0 $buttons(zoom,rot,0) \
	current(rotate) 0 ChangeRotate
    RadioButton $ds9(buttons).zoom.r90 $buttons(zoom,rot,90) \
	current(rotate) 90 ChangeRotate
    RadioButton $ds9(buttons).zoom.r180 $buttons(zoom,rot,180) \
	current(rotate) 180 ChangeRotate
    RadioButton $ds9(buttons).zoom.r270 $buttons(zoom,rot,270) \
	current(rotate) 270 ChangeRotate
}

proc UpdateZoomMenu {} {
    global ds9
    global current
    global wcs
    global menu
    global panzoom
    
    global debug
    if {$debug(tcl,update)} {
	puts "UpdateZoomMenu"
    }

    UpdateAlignWCSMenu $ds9(mb).zoom

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig $menu(zoom) -state normal
	$ds9(buttons).major.zoom configure -state normal

	set panzoom(preserve) [$current(frame) get pan preserve]

	if {[$current(frame) has fits]} {
	    $ds9(mb).zoom entryconfig $menu(zoom,zoom,tofit) -state normal
	} else {
	    $ds9(mb).zoom entryconfig $menu(zoom,zoom,tofit) -state disabled
	}

	set current(zoom) [$current(frame) get zoom]
	set current(rotate) [$current(frame) get rotate]
	set current(orient) [$current(frame) get orient]
	set align [$current(frame) get wcs align]

	set wcs(align) [lindex $align 0]
	set wcs(align,system) [lindex $align 1]
	set wcs(align,sky) [lindex $align 2]
    } else {
	$ds9(mb) entryconfig $menu(zoom) -state disabled
	$ds9(buttons).major.zoom configure -state disabled

	set panzoom(preserve) 0

	set current(zoom) { 1 1 }
	set current(rotate) 0
	set current(orient) none

	set wcs(align) 0
	set wcs(align,system) wcs
	set wcs(align,sky) fk5
    }
}

proc UpdateAlignWCSMenu {which} {
    global current
    global wcs
    global menu

    # no frame
    if {$current(frame) == {}} {
	$which entryconfig $menu(zoom,align) -state disabled
	$which entryconfig $menu(zoom,align,wcs) -state disabled
	return
    }

    # unloaded frame
    if {![$current(frame) has fits]} {
	$which entryconfig $menu(zoom,align)  -state normal
	$which entryconfig $menu(zoom,align,wcs) -state normal

	$which.align entryconfig $menu(wcs) -state normal
	$which.align entryconfig $menu(wcs,multi) -state normal

	$which.align entryconfig $menu(wcs,fk4) -state normal
	$which.align entryconfig $menu(wcs,fk5) -state normal
	$which.align entryconfig $menu(wcs,icrs) -state normal
	$which.align entryconfig $menu(wcs,galactic) -state normal
	$which.align entryconfig $menu(wcs,ecliptic) -state normal

	foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	    $which.align.wcs entryconfig "$menu(wcs) $l" \
		-state normal
	}
	return
    }

    # loaded frame
    $which entryconfig $menu(zoom,align) -state normal
    $which entryconfig $menu(zoom,align,wcs) -state normal

    if {[$current(frame) has wcs WCS]} {
	$which.align entryconfig $menu(wcs) -state normal
    } else {
	$which.align entryconfig $menu(wcs) -state disabled
    }
    $which.align entryconfig $menu(wcs,multi) -state normal
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {[$current(frame) has wcs WCS$l]} {
	    $which.align.wcs entryconfig "$menu(wcs) $l" \
		-state normal
	} else {
	    $which.align.wcs entryconfig "$menu(wcs) $l" \
		-state disabled
	}
    }

    SetSkyFrameMenu2 $which.align disabled

    if {$current(frame) != {}} {
	if {[$current(frame) has fits]} {
	    switch -- $wcs(align,system) {
		wcs {}
		default {
		    if {![$current(frame) has wcs $wcs(align,system)]} {
			    set wcs(align,system) wcs
		    }
		}
	    }

	    if [$current(frame) has wcs equatorial $wcs(align,system)] {
		SetSkyFrameMenu2 $which.align normal
	    }
	}
    }
}

