#! /bin/sh

echo "Analysis Tests"
echo

echo "Starting DS9..."
if [ `xpaaccess ds9` = no ]
then
    ds9&
fi

i=1
while [ "$i" -le 30 ]
do
    sleep 2
    if [ `xpaaccess ds9` = yes ]
    then
	break
    fi

    i=`expr $i + 1`
done

# load default
xpaset -p ds9 scale zscale
xpaset -p ds9 file img16.fits
xpaset -p ds9 regions file analysis.reg
xpaset -p ds9 analysis load analysis.ans

if [ "$1" = "plot" -o  -z "$1" ]; then
echo "Testing Text/Plot"
echo "This is a Test Text Message" | xpaset ds9 analysis text
cat xy.dat | xpaset ds9 analysis plot
cat xyexey.dat | xpaset ds9 analysis plot "{Plot Test}" X Y xyexey
cat stdin.xyey.dat | xpaset ds9 analysis plot stdin
xpaset -p ds9 raise
echo "PASSED"
fi

# Analysis
if [ "$1" = "analysis" -o  -z "$1" ]; then
echo "Testing Analysis File"
xpaget ds9 analysis > /dev/null
fi

# Main
if [ "$1" = "help" -o  -z "$1" ]; then
i=1
echo "$i Help"
xpaset -p ds9 analysis $i
fi

# Web
if [ "$1" = "web" -o  -z "$1" ]; then
i=`expr $i + 1`
echo "$i Web"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i web url"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i web file"
xpaset -p ds9 analysis $i
fi

# Basics
if [ "$1" = "basics" -o  -z "$1" ]; then
i=`expr $i + 1`
echo "Basic"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i escape macro"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i non macro"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$xpa"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$xpa_method"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$filename"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$filename(root)"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$xdim $ydim $bitpix"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$env"
xpaset -p ds9 analysis $i
fi

# Regions
if [ "$1" = "regions" -o  -z "$1" ]; then
i=`expr $i + 1`
echo "$i Regions"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$regions"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$regions wcs"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$include_regions_pixels"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$filename $regions"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$regions()"
xpaset -p ds9 analysis $i
fi

# Output
if [ "$1" = "output" -o  -z "$1" ]; then
i=`expr $i + 1`
echo "$i Output"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$null"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$text"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$text stderr"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot(title,x,y,xyey)"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot(title,x,y,xyexey)"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot(title,x,y,4)"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot(title,x,y,5)"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot(stdin)"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot(stdin) text"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$plot(stdin) error"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$data"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$image"
xpaset -p ds9 analysis $i
fi

# Dialogs
if [ "$1" = "dialogs" -o  -z "$1" ]; then
i=`expr $i + 1`
echo "$i Dialog"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$message(message)"

i=`expr $i + 1`
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$message(ok,message)"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$entry(message)"
xpaset -p ds9 analysis $i
fi

# Params
if [ "$1" = "params" -o  -z "$1" ]; then
i=`expr $i + 1`
echo "$i Param"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$param"
xpaset -p ds9 analysis $i

i=`expr $i + 1`
echo "..$i \$param @file"
xpaset -p ds9 analysis $i
fi

echo "PASSED"

# Other
if [ "$1" = "other" -o  -z "$1" ]; then
xpaset -p ds9 analysis message {press 'x','y','z' to test interactive}
fi

#xpaset -p ds9 quit
echo "Done"
